# coding: utf-8

"""
    Sidra API

    Sidra API  # noqa: E501

    Sidra API version: 1.12.0.post19
    Contact: sidra@plainconcepts.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

class AssetsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            raise ValueError("api_client is mandatory")
        self.api_client = api_client

    def api_assets_id_tokens_get(self, id, **kwargs):  # noqa: E501
        """Gets a list of URLs to download the raw copy of the asset.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_assets_id_tokens_get(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int id: Id of Asset to download. (required)
        :param int expiration_in_hours: Expiration of the SAS token used in the URLs. By default is 1 hour.
        :param str content_type: Optionally, a value to populate Content-Type header on the SAS token returned. By default, it will be inferred according to the type defined in the               Entity Format field. In case of not supported/inferred, it will return application/octet-stream. In case of providing a value, it will use that value.
        :param str api_version: The requested API version
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.api_assets_id_tokens_get_with_http_info(id, **kwargs)  # noqa: E501
        else:
            (data) = self.api_assets_id_tokens_get_with_http_info(id, **kwargs)  # noqa: E501
            return data

    def api_assets_id_tokens_get_with_http_info(self, id, **kwargs):  # noqa: E501
        """Gets a list of URLs to download the raw copy of the asset.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.api_assets_id_tokens_get_with_http_info(id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int id: Id of Asset to download. (required)
        :param int expiration_in_hours: Expiration of the SAS token used in the URLs. By default is 1 hour.
        :param str content_type: Optionally, a value to populate Content-Type header on the SAS token returned. By default, it will be inferred according to the type defined in the               Entity Format field. In case of not supported/inferred, it will return application/octet-stream. In case of providing a value, it will use that value.
        :param str api_version: The requested API version
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['id', 'expiration_in_hours', 'content_type', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method api_assets_id_tokens_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'id' is set
        if ('id' not in params or
                params['id'] is None):
            raise ValueError("Missing the required parameter `id` when calling `api_assets_id_tokens_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'id' in params:
            path_params['id'] = params['id']  # noqa: E501

        query_params = []
        if 'expiration_in_hours' in params:
            query_params.append(('expirationInHours', params['expiration_in_hours']))  # noqa: E501
        if 'content_type' in params:
            query_params.append(('contentType', params['content_type']))  # noqa: E501
        if 'api_version' in params:
            query_params.append(('api-version', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/api/assets/{id}/tokens', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='str',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def asset_download_url_status_route(self, run_id, **kwargs):  # noqa: E501
        """Checks the status of generation of the URLs to download the raw copy of the asset. It provides the URLs if the process has completed.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.asset_download_url_status_route(run_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int run_id: RunId of the query to check (required)
        :param str polling_token: The polling token that contains the information about the query execution to check. This parameter is mandatory.
        :param str content_type: Optionally, a value to populate content-Type header on the SAS token returned. By default, it will be inferred according to the type defined in the               Entity Format field. In case of not supported/inferred, it will return application/octet-stream. In case of providing a value, it will use that value.
        :param str api_version: The requested API version
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.asset_download_url_status_route_with_http_info(run_id, **kwargs)  # noqa: E501
        else:
            (data) = self.asset_download_url_status_route_with_http_info(run_id, **kwargs)  # noqa: E501
            return data

    def asset_download_url_status_route_with_http_info(self, run_id, **kwargs):  # noqa: E501
        """Checks the status of generation of the URLs to download the raw copy of the asset. It provides the URLs if the process has completed.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.asset_download_url_status_route_with_http_info(run_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int run_id: RunId of the query to check (required)
        :param str polling_token: The polling token that contains the information about the query execution to check. This parameter is mandatory.
        :param str content_type: Optionally, a value to populate content-Type header on the SAS token returned. By default, it will be inferred according to the type defined in the               Entity Format field. In case of not supported/inferred, it will return application/octet-stream. In case of providing a value, it will use that value.
        :param str api_version: The requested API version
        :return: str
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['run_id', 'polling_token', 'content_type', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method asset_download_url_status_route" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'run_id' is set
        if ('run_id' not in params or
                params['run_id'] is None):
            raise ValueError("Missing the required parameter `run_id` when calling `asset_download_url_status_route`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'run_id' in params:
            path_params['runId'] = params['run_id']  # noqa: E501

        query_params = []
        if 'polling_token' in params:
            query_params.append(('pollingToken', params['polling_token']))  # noqa: E501
        if 'content_type' in params:
            query_params.append(('contentType', params['content_type']))  # noqa: E501
        if 'api_version' in params:
            query_params.append(('api-version', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['text/plain', 'application/json', 'text/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['oauth2']  # noqa: E501

        return self.api_client.call_api(
            '/api/assets/{runId}/status', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='str',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
