# coding: utf-8

"""
    Sidra API

    Sidra API  # noqa: E501

    Sidra API version: 1.12.0.post19
    Contact: sidra@plainconcepts.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import json
from time import sleep


class Authentication:
    def __init__(
        self, api_client, base_url, scope, client_id, client_secret, grant_type="client_credentials"
    ):
        if api_client is None:
            raise ValueError("api_client cannot be None")
        self.api_client = api_client
        self.base_url = base_url
        self.scope = scope
        self.client_id = client_id
        self.client_secret = client_secret
        self.headers = {"Content-Type": "application/x-www-form-urlencoded"}
        self.post_params = {"grant_type": grant_type,
                            "scope": scope,
                            "client_id": client_id,
                            "client_secret": client_secret}

    def get_token(self, json_error_sleep_t=30, json_error_retry_times=10):
        token = ""
        authenticated = False
        while not authenticated and json_error_retry_times > 0:
            try:
                token = json.loads(self.api_client.rest_client.POST(self.base_url,
                                                                    headers=self.headers,
                                                                    post_params=self.post_params).data
                                   )["access_token"]
                authenticated = True
            except json.JSONDecodeError as json_error:
                print("Error while authenticating against Sidra API: {0}. Trying in {1} seconds"
                      .format(json_error, json_error_sleep_t))
                sleep(json_error_sleep_t)
                json_error_retry_times -= 1

        return token
